component: GpuMonitor
proto_imports:
  - vehicle/computer_hardware/diagnostics/gpu_monitor_diagnostics.proto
metric: AllGpuMetrics
namespace: zoox::computer_hardware
faults:
  - id: 1
    name: GpuQueryError
    severity: WARNING
    description: Error seen when querying the GPUs for metrics
  - id: 2
    name: GpuTemperatureWarning
    severity: WARNING
    description: Temperature of at least one GPU has reached the warning threshold
    freeze_frame: GpuMonitorFreezeFrame
  - id: 3
    name: GpuTemperatureError
    severity: WARNING
    description: Temperature of at least one GPU has reached the error threshold
    freeze_frame: GpuMonitorFreezeFrame
  - id: 4
    name: GpuMemoryUseWarning
    severity: WARNING
    description: Memory usage of at least one GPU has reached the warning threshold
    freeze_frame: GpuMonitorFreezeFrame
  - id: 5
    name: GpuMemoryUseError
    severity: WARNING
    description: Memory usage of at least one GPU has reached the error threshold
    freeze_frame: GpuMonitorFreezeFrame
  - id: 6
    name: GpuMissingError
    severity: WARNING
    description: One or more of the expected GPUs is not reachable
  - id: 7
    name: GpuThrottledError
    severity: WARNING
    description: One or more of the GPUs is being HW throttled
    freeze_frame: GpuMonitorFreezeFrame
  - id: 8
    name: GpuThrottledWarning
    severity: WARNING
    description: One or more of the GPUs is being SW throttled
    freeze_frame: GpuMonitorFreezeFrame
  - id: 9
    name: GpuDriverNotLoadedError
    severity: WARNING
    description: The GPU driver is not loaded. Contact RSI for support and prepare to reimage vehicle
  - id: 10
    name: GpuDriverIncorrectVersion
    severity: WARNING
    description: The GPU driver is not the correct version. Contact RSI for support and prepare to reimage vehicle
  - id: 11
    name: GpuUVMDriverNotLoadedError
    severity: ERROR
    description: The GPU UVM driver is not loaded. Contact RSI for support and prepare to reimage vehicle
    triggers_nogo: true
  - id: 12
    name: GpuMetricGenerationError
    severity: WARNING
    description: Error detected when attempting to gather GPU metrics. Code should be updated to explicitly identify the issue
